package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.GameEventConfigBo;
import org.dromara.system.domain.vo.GameEventConfigVo;
import org.dromara.system.domain.GameEventConfig;
import org.dromara.system.mapper.GameEventConfigMapper;
import org.dromara.system.service.IGameEventConfigService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 赛事配置Service业务层处理
 *
 * @author zlt
 * @date 2025-07-31
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class GameEventConfigServiceImpl implements IGameEventConfigService {

    private final GameEventConfigMapper baseMapper;

    /**
     * 查询赛事配置
     *
     * @param configId 主键
     * @return 赛事配置
     */
    @Override
    public GameEventConfigVo queryById(Long configId){
        return baseMapper.selectVoById(configId);
    }

    /**
     * 分页查询赛事配置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 赛事配置分页列表
     */
    @Override
    public TableDataInfo<GameEventConfigVo> queryPageList(GameEventConfigBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<GameEventConfig> lqw = buildQueryWrapper(bo);
        Page<GameEventConfigVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的赛事配置列表
     *
     * @param bo 查询条件
     * @return 赛事配置列表
     */
    @Override
    public List<GameEventConfigVo> queryList(GameEventConfigBo bo) {
        LambdaQueryWrapper<GameEventConfig> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<GameEventConfig> buildQueryWrapper(GameEventConfigBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<GameEventConfig> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(GameEventConfig::getConfigId);
        lqw.eq(bo.getEventId() != null, GameEventConfig::getEventId, bo.getEventId());
        lqw.eq(StringUtils.isNotBlank(bo.getConfigType()), GameEventConfig::getConfigType, bo.getConfigType());
        lqw.like(StringUtils.isNotBlank(bo.getConfigDesc()), GameEventConfig::getConfigDesc, bo.getConfigDesc());
        lqw.eq(StringUtils.isNotBlank(bo.getIsEnabled()), GameEventConfig::getIsEnabled, bo.getIsEnabled());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), GameEventConfig::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增赛事配置
     *
     * @param bo 赛事配置
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(GameEventConfigBo bo) {
        GameEventConfig add = MapstructUtils.convert(bo, GameEventConfig.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setConfigId(add.getConfigId());
        }
        return flag;
    }

    /**
     * 修改赛事配置
     *
     * @param bo 赛事配置
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(GameEventConfigBo bo) {
        GameEventConfig update = MapstructUtils.convert(bo, GameEventConfig.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(GameEventConfig entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除赛事配置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
